;;; smilisp.sl --- Smilisp self-implementation                    -*- lisp -*-

;; Copyright (C) 2008 Didier Verna

;; Author:        Didier Verna <didier@lrde.epita.fr>
;; Maintainer:    Didier Verna <didier@lrde.epita.fr>
;; Created:       Wed Apr  1 00:00:00 2009
;; Last Revision: Wed Apr  1 23:59:59 2009


;;; Commentary:

;; Contents management by FCM version 0.1.


;; This file is part of Smilisp.

;; Smilisp is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2 of the License, or
;; (at your option) any later version.

;; Smilisp is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;;; Code:

:o(defun |:-reader| :o(s |:| :-)
  :o(declare :o(ignore |:| :-):-)
  :o(let :o(:o(nose :o(read-char s t nil t :-):-):-)
    :o(case nose
      :o(:o(#\- #\o :-)
       :o(let :o(:o(mouth :o(peek-char nil s t nil t :-):-):-)
	 :o(case mouth
	   :o(:o(#\( #\) :-)
	    :o(values :-):-)
	   :o(otherwise
	    :o(intern :o(concatenate 'string
			  :o(make-string 1
			      :initial-element :o(char-upcase nose :-):-)
			  :o(symbol-name :o(read s t nil t :-):-):-)
		      :keyword :-):-):-):-):-)
      :o(otherwise
	 :o(unread-char nose s :-)
	 :o(intern :o(symbol-name :o(read s t nil t :-):-)
		   :keyword :-):-):-):-):-)

:o(set-macro-character #\: #'|:-reader| :non-terminating :-)


;;; smilisp.sl ends here
